﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MSHO.Collection.Service
{
    public class ClearHistoryFileService
    {
        private System.Threading.Timer m_Timer;
        private bool m_Running = false;
        private bool m_IsRunning = false;

        public ClearHistoryFileService() { }

        public void Start()
        {
            m_Running = true;
            m_Timer = new System.Threading.Timer(delegate (object state)
            {
                try
                {
                    if (m_IsRunning == false)
                    {
                        m_IsRunning = true;

                        if (m_Running)
                        {
                            try
                            {
                                var service = System.ServiceProcess.ServiceController.GetServices();
                                foreach (var sc in service) {
                                    if (string.Compare(sc.ServiceName, "HK.File.Service", true) == 0)
                                    {
                                        if (sc.Status == System.ServiceProcess.ServiceControllerStatus.Stopped)
                                        {
                                            try
                                            {
                                                sc.Start();
                                            }
                                            catch
                                            {
                                            }
                                        }
                                    }
                                }
                            }
                            catch
                            {
                            }
                        }


                        if (m_Running)
                        {
                            var hardDisk = System.Configuration.ConfigurationManager.AppSettings["HardDisk"];
                            if (!string.IsNullOrEmpty(hardDisk))
                            {
                                var freeSpace = GetHardDiskSpace(hardDisk);
                                while (m_Running && freeSpace <= 10)
                                {
                                    var fileQuery = MSHO.Collection.DataAccess.MSHOService.Instance.GetWeightingFiles();
                                    var files = fileQuery.Take(100).ToArray();
                                    foreach (var file in files)
                                    {
                                        try
                                        {
                                            MSHO.Collection.DataAccess.MSHOService.Instance.DeleteWeightingFile(file.ID);
                                        }
                                        catch(Exception ex) {
                                            Console.WriteLine(ex.Message);
                                        }
                                        if (m_Running == false)
                                        {
                                            break;
                                        }
                                    }

                                    var dir = System.Configuration.ConfigurationManager.AppSettings["MSHO_DIR"];

                                    if (m_Running)
                                    {
                                        var logDir = new System.IO.DirectoryInfo(System.IO.Path.Combine(dir, "__Log"));
                                        foreach (var file in logDir.GetFiles())
                                        {
                                            try
                                            {
                                                file.Delete();
                                            }
                                            catch { }
                                        }
                                    }

                                    //if (m_Running)
                                    //{
                                    //    var tempDir = new System.IO.DirectoryInfo(System.IO.Path.Combine(dir, "__Temp"));
                                    //    foreach (var file in tempDir.GetFiles())
                                    //    {
                                    //        try
                                    //        {
                                    //            file.Delete();
                                    //        }
                                    //        catch { }
                                    //    }
                                    //}

                                    freeSpace = GetHardDiskSpace(hardDisk);
                                }
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    MSHO.Collection.DataAccess.MSHOService.Instance.SaveSystemLog("MSHO.Collection.Service", "ClearHistoryFileService", ex);
                }
                finally {
                    m_IsRunning = false;
                }
            }, this, new TimeSpan(0, 0, 0), new TimeSpan(0, 5, 0));
        }

        /// <summary>
        /// GB
        /// </summary>
        /// <param name="str_HardDiskName"></param>
        /// <returns></returns>
        public long GetHardDiskSpace(string str_HardDiskName)
        {
            long totalSize = 0;
            try
            {
                str_HardDiskName = str_HardDiskName + ":\\";
                System.IO.DriveInfo[] drives = System.IO.DriveInfo.GetDrives();
                foreach (System.IO.DriveInfo drive in drives)
                {
                    if (drive.Name == str_HardDiskName)
                    {
                        totalSize = drive.TotalFreeSpace / (1024 * 1024 * 1024);
                        break;
                    }
                }
            }
            catch {

            }
            return totalSize;
        }

        public void Stop() {
            m_Running = false;
            if (m_Timer != null)
            {
                m_Timer.Dispose();
                m_Timer = null;
            }
        }

    }
}
