﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MSHO.Collection.Service
{
    public class Configuration
    {
        private static Configuration m_Instance = new Configuration();
        private Configuration() { }

        public static Configuration Instance {
            get {
                return m_Instance;
            }
        }

        private string AppSetting(string key) {
            return System.Configuration.ConfigurationManager.AppSettings[key];
        }

        public string IP {
            get {
                return AppSetting("IP");
            }
        }

        public string FileServerConnection {
            get {
                return AppSetting("FileServerConnection");
            }
        }

        public int Port {
            get {
                int n = 0;
                if (int.TryParse(AppSetting("Port"), out n)) {
                    return n;
                }

                return 8888;
            }
        }

        public int MaxConnection {
            get {
                int n = 0;
                if (int.TryParse(AppSetting("MaxConnection"), out n))
                {
                    return n;
                }

                return 100;
            }
        }

        public int BufferSize {
            get {
                int n = 0;
                if (int.TryParse(AppSetting("BufferSize"), out n))
                {
                    return n;
                }

                return 4096;
            }
        }


    }
}
