﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MSHO.Collection.Service.IO
{
    /// <summary>
    /// 可序列化为JSON
    /// </summary>
    public class JsonSerializable
    {
        /// <summary>
        /// 对象转json
        /// </summary>
        /// <returns></returns>
        public static string ToJson(object obj) {
            var ser = new Newtonsoft.Json.JsonSerializer();

            var sb = new StringBuilder();
            var writer = new System.IO.StringWriter(sb);
            ser.Serialize(writer, obj);

            return sb.ToString();
        }

        /// <summary>
        /// json转对象
        /// </summary>
        /// <param name="json"></param>
        public static T FromJson<T>(string json) where T: class {
            var ser = new Newtonsoft.Json.JsonSerializer();

            var reader = new System.IO.StringReader(json);

            return ser.Deserialize(reader, typeof(T)) as T;
        }

        public static IList<T> FromListJson<T>(string json) where T : class
        {
            var ser = new Newtonsoft.Json.JsonSerializer();

            var reader = new System.IO.StringReader(json);

            return ser.Deserialize(reader, typeof(IList<T>)) as IList<T>;
        }
    }

}
