﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Threading.Tasks;

namespace MSHO.Collection.Service
{
    public partial class MainService : ServiceBase
    {
        private ClearHistoryFileService m_ClearHistoryFileService;
        private MSHO.Collection.Service.IO.IOServer m_IOServer;
        public MainService()
        {
            InitializeComponent();
        }

        protected override void OnStart(string[] args)
        {
            var config = MSHO.Collection.Service.Configuration.Instance;
            m_IOServer = new MSHO.Collection.Service.IO.IOServer(config.IP, config.Port, config.MaxConnection, config.BufferSize);

            m_IOServer.Start();

            m_ClearHistoryFileService = new ClearHistoryFileService();
            m_ClearHistoryFileService.Start();
        }

        protected override void OnStop()
        {
            if (m_IOServer != null) {
                m_IOServer.Stop();
            }

            if (m_ClearHistoryFileService != null) {
                m_ClearHistoryFileService.Stop();
                m_ClearHistoryFileService = null;
            }
        }
    }
}
